# This file was created automatically by SWIG.
import equationc
from ooflib.SWIG.engine.fieldindex import IteratorPPtr
from ooflib.SWIG.engine.fieldindex import IndexPPtr
from ooflib.SWIG.engine.flux import FluxPtr
class EquationPtr :
    def __init__(self,this):
        self.this = this
        self.thisown = 0
    def name(self, *_args, **_kwargs):
        val = apply(equationc.Equation_name,(self,) + _args, _kwargs)
        return val
    def objectid(self, *_args, **_kwargs):
        val = apply(equationc.Equation_objectid,(self,) + _args, _kwargs)
        return val
    def dim(self, *_args, **_kwargs):
        val = apply(equationc.Equation_dim,(self,) + _args, _kwargs)
        return val
    def ndof(self, *_args, **_kwargs):
        val = apply(equationc.Equation_ndof,(self,) + _args, _kwargs)
        return val
    def nodaleqn(self, *_args, **_kwargs):
        val = apply(equationc.Equation_nodaleqn,(self,) + _args, _kwargs)
        if val: val = NodalEquationPtr(val) 
        return val
    def iterator(self, *_args, **_kwargs):
        val = apply(equationc.Equation_iterator,(self,) + _args, _kwargs)
        if val: val = IteratorPPtr(val) ; val.thisown = 1
        return val
    def iterator_all(self, *_args, **_kwargs):
        val = apply(equationc.Equation_iterator_all,(self,) + _args, _kwargs)
        if val: val = IteratorPPtr(val) ; val.thisown = 1
        return val
    def componenttype(self, *_args, **_kwargs):
        val = apply(equationc.Equation_componenttype,(self,) + _args, _kwargs)
        if val: val = IndexPPtr(val) ; val.thisown = 1
        return val
    def getIndex(self, *_args, **_kwargs):
        val = apply(equationc.Equation_getIndex,(self,) + _args, _kwargs)
        if val: val = IndexPPtr(val) ; val.thisown = 1
        return val
    def is_active(self, *_args, **_kwargs):
        val = apply(equationc.Equation_is_active,(self,) + _args, _kwargs)
        return val
    def allow_boundary_conditions(self, *_args, **_kwargs):
        val = apply(equationc.Equation_allow_boundary_conditions,(self,) + _args, _kwargs)
        return val
    def __repr__(self):
        return "<C Equation instance at %s>" % (self.this,)
class Equation(EquationPtr):
    def __init__(self,this):
        self.this = this




class FluxEquationPtr(EquationPtr):
    def __init__(self,this):
        self.this = this
        self.thisown = 0
    def fluxname(self, *_args, **_kwargs):
        val = apply(equationc.FluxEquation_fluxname,(self,) + _args, _kwargs)
        return val
    def flux(self, *_args, **_kwargs):
        val = apply(equationc.FluxEquation_flux,(self,) + _args, _kwargs)
        return val
    def __repr__(self):
        return "<C FluxEquation instance at %s>" % (self.this,)
class FluxEquation(FluxEquationPtr):
    def __init__(self,this):
        self.this = this




class NaturalEquationPtr(EquationPtr):
    def __init__(self,this):
        self.this = this
        self.thisown = 0
    def __repr__(self):
        return "<C NaturalEquation instance at %s>" % (self.this,)
class NaturalEquation(NaturalEquationPtr):
    def __init__(self,*_args,**_kwargs):
        self.this = apply(equationc.new_NaturalEquation,_args,_kwargs)
        self.thisown = 1




class DivergenceEquationPtr(FluxEquationPtr):
    def __init__(self,this):
        self.this = this
        self.thisown = 0
    def __repr__(self):
        return "<C DivergenceEquation instance at %s>" % (self.this,)
class DivergenceEquation(DivergenceEquationPtr):
    def __init__(self,*_args,**_kwargs):
        self.this = apply(equationc.new_DivergenceEquation,_args,_kwargs)
        self.thisown = 1




class PlaneFluxEquationPtr(FluxEquationPtr):
    def __init__(self,this):
        self.this = this
        self.thisown = 0
    def __repr__(self):
        return "<C PlaneFluxEquation instance at %s>" % (self.this,)
class PlaneFluxEquation(PlaneFluxEquationPtr):
    def __init__(self,*_args,**_kwargs):
        self.this = apply(equationc.new_PlaneFluxEquation,_args,_kwargs)
        self.thisown = 1






#-------------- FUNCTION WRAPPERS ------------------

countEquations = equationc.countEquations

def getEquationByIndex(*_args, **_kwargs):
    val = apply(equationc.getEquationByIndex,_args,_kwargs)
    return val

def getEquationByName(*_args, **_kwargs):
    val = apply(equationc.getEquationByName,_args,_kwargs)
    return val



#-------------- VARIABLE WRAPPERS ------------------



#-------------- USER INCLUDE -----------------------

# -*- python -*-
# $RCSfile: equation.spy,v $
# $Revision: 1.6 $
# $Author: langer $
# $Date: 2010-12-05 05:06:21 $

# This software was produced by NIST, an agency of the U.S. government,
# and by statute is not subject to copyright in the United States.
# Recipients of this software assume all responsibilities associated
# with its operation, modification and maintenance. However, to
# facilitate maintenance we ask that before distributing modified
# versions of this software, you first contact the authors at
# oof_manager@nist.gov.

from ooflib.common import debug
from ooflib.common import utils
import types

def _Equation___hash_(self):
    return self.objectid()

EquationPtr.__hash__ = _Equation___hash_

def _Equation___cmp__(self, other):
    if not isinstance(other, EquationPtr): return -1
    if self.objectid() < other.objectid(): return -1
    if self.objectid() > other.objectid(): return 1
    return 0

EquationPtr.__cmp__ = _Equation___cmp__

EquationPtr.__repr__ = EquationPtr.name


DivergenceEquationPtr.__repr__ = DivergenceEquationPtr.name

PlaneFluxEquationPtr.__repr__ = PlaneFluxEquationPtr.name

from ooflib.SWIG.engine.nodalequation import NodalEquationPtr

# AllEquations acts like a list of Equations
class _AllEquations:
    def __getitem__(self, indx):
        if type(indx) == types.IntType:
            if indx >= countEquations() or indx < 0:
                raise IndexError("Bad equation index: " + str(indx))
            return getEquationByIndex(indx)
        elif type(indx) == types.StringType:
            return getEquationByName(indx)
    def __len__(self):
        return countEquations()

allEquations = _AllEquations()

def getEquation(name):
    return getEquationByName(name)

utils.OOFdefine('getEquation', getEquation)

