# This file was created automatically by SWIG.
import stressfreestrainc
from ooflib.SWIG.engine.properties import PropertyPtr
from ooflib.SWIG.engine.symmmatrix import SymmMatrix3Ptr
class IsotropicStressFreeStrainPtr(PropertyPtr):
    def __init__(self,this):
        self.this = this
        self.thisown = 0
    def __repr__(self):
        return "<C IsotropicStressFreeStrain instance at %s>" % (self.this,)
class IsotropicStressFreeStrain(IsotropicStressFreeStrainPtr):
    def __init__(self,*_args,**_kwargs):
        self.this = apply(stressfreestrainc.new_IsotropicStressFreeStrain,_args,_kwargs)
        self.thisown = 1




class AnisotropicStressFreeStrainPtr(PropertyPtr):
    def __init__(self,this):
        self.this = this
        self.thisown = 0
    def __repr__(self):
        return "<C AnisotropicStressFreeStrain instance at %s>" % (self.this,)
class AnisotropicStressFreeStrain(AnisotropicStressFreeStrainPtr):
    def __init__(self,*_args,**_kwargs):
        self.this = apply(stressfreestrainc.new_AnisotropicStressFreeStrain,_args,_kwargs)
        self.thisown = 1






#-------------- FUNCTION WRAPPERS ------------------



#-------------- VARIABLE WRAPPERS ------------------



#-------------- USER INCLUDE -----------------------

# -*- python -*-
# $RCSfile: stressfreestrain.spy,v $
# $Revision: 1.8 $
# $Author: langer $
# $Date: 2011-05-25 21:45:25 $

# This software was produced by NIST, an agency of the U.S. government,
# and by statute is not subject to copyright in the United States.
# Recipients of this software assume all responsibilities associated
# with its operation, modification and maintenance. However, to
# facilitate maintenance we ask that before distributing modified
# versions of this software, you first contact the authors at
# oof_manager@nist.gov. 


from ooflib.SWIG.engine import symmmatrix
from ooflib.common import utils
from ooflib.common.IO import parameter
from ooflib.common.IO import xmlmenudump
from ooflib.engine import problem
from ooflib.engine import propertyregistration

PropertyRegistration = propertyregistration.PropertyRegistration

#########

reg = PropertyRegistration(
    'Mechanical:StressFreeStrain:Isotropic',
    IsotropicStressFreeStrain,
    "ooflib.SWIG.engine.property.stressfreestrain.stressfreestrain",
    22,
    [parameter.FloatParameter('epsilon0', 0.0, tip="StressFreeStrain")],
    outputs=["Strain", "Energy"],
    propertyType="StressFreeStrain",
    tip="Isotropic stress-free strain",
    discussion=xmlmenudump.loadFile(
        'DISCUSSIONS/engine/property/isostressfreestrain.xml'))

reg.fluxInfo(fluxes=[problem.Stress])

#########

reg = PropertyRegistration(
    'Mechanical:StressFreeStrain:Anisotropic:Cubic',
    AnisotropicStressFreeStrain,
    "ooflib.SWIG.engine.property.stressfreestrain.stressfreestrain",
    23,
    [symmmatrix.CubicRank2TensorParameter(
            'epsilon0',
            symmmatrix.CubicRank2Tensor(xx=1.0),
            tip='Stress-free strain tensor')],
    outputs=["Strain", "Energy"],
    propertyType="StressFreeStrain",
    tip="Cubic stress-free strain",
    discussion=xmlmenudump.loadFile(
        'DISCUSSIONS/engine/property/anisostressfreestrain.xml'))

reg.fluxInfo(fluxes=[problem.Stress])
    
#########

reg = PropertyRegistration(
    'Mechanical:StressFreeStrain:Anisotropic:Hexagonal',
    AnisotropicStressFreeStrain,
    "ooflib.SWIG.engine.property.stressfreestrain.stressfreestrain",
    24,
    [symmmatrix.HexagonalRank2TensorParameter(
            'epsilon0',
            symmmatrix.HexagonalRank2Tensor(xx=1.0, zz=0.5),
            tip='Stress-free strain tensor')],
    outputs=["Strain", "Energy"],
    propertyType="StressFreeStrain",
    tip="Hexagonal stress-free strain",
    discussion=xmlmenudump.loadFile(
        'DISCUSSIONS/engine/property/anisostressfreestrain.xml'))

reg.fluxInfo(fluxes=[problem.Stress])
    
#########

reg = PropertyRegistration(
    'Mechanical:StressFreeStrain:Anisotropic:Trigonal',
    AnisotropicStressFreeStrain,
    "ooflib.SWIG.engine.property.stressfreestrain.stressfreestrain",
    25,
    [symmmatrix.TrigonalRank2TensorParameter(
            'epsilon0',
            symmmatrix.TrigonalRank2Tensor(xx=1.0, zz=0.5),
            tip='Stress-free strain tensor')],
    outputs=["Strain", "Energy"],
    propertyType="StressFreeStrain",
    tip="Trigonal stress-free strain",
    discussion=xmlmenudump.loadFile(
        'DISCUSSIONS/engine/property/anisostressfreestrain.xml'))

reg.fluxInfo(fluxes=[problem.Stress])
    
#########

reg = PropertyRegistration(
    'Mechanical:StressFreeStrain:Anisotropic:Tetragonal',
    AnisotropicStressFreeStrain,
    "ooflib.SWIG.engine.property.stressfreestrain.stressfreestrain",
    26,
    [symmmatrix.TetragonalRank2TensorParameter(
            'epsilon0',
            symmmatrix.TetragonalRank2Tensor(xx=1.0, zz=0.5),
            tip='Stress-free strain tensor')],
    outputs=["Strain", "Energy"],
    propertyType="StressFreeStrain",
    tip="Tetragonal stress-free strain",
    discussion=xmlmenudump.loadFile(
        'DISCUSSIONS/engine/property/anisostressfreestrain.xml'))

reg.fluxInfo(fluxes=[problem.Stress])
    
#########

reg = PropertyRegistration(
    'Mechanical:StressFreeStrain:Anisotropic:Orthorhombic',
    AnisotropicStressFreeStrain,
    "ooflib.SWIG.engine.property.stressfreestrain.stressfreestrain",
    27,
    [symmmatrix.OrthorhombicRank2TensorParameter(
            'epsilon0',
            symmmatrix.OrthorhombicRank2Tensor(xx=1.0, yy=1.0, zz=1.0),
            tip='Stress-free strain tensor')],
    outputs=["Strain", "Energy"],
    propertyType="StressFreeStrain",
    tip="Orthorhombic stress-free strain",
    discussion=xmlmenudump.loadFile(
        'DISCUSSIONS/engine/property/anisostressfreestrain.xml'))

reg.fluxInfo(fluxes=[problem.Stress])
    
#########

reg = PropertyRegistration(
    'Mechanical:StressFreeStrain:Anisotropic:Monoclinic',
    AnisotropicStressFreeStrain,
    "ooflib.SWIG.engine.property.stressfreestrain.stressfreestrain",
    26,
    [symmmatrix.MonoclinicRank2TensorParameter(
            'epsilon0',
            symmmatrix.MonoclinicRank2Tensor(xx=1.0, yy=1.0, zz=1.0),
            tip='Stress-free strain tensor')],
    outputs=["Strain", "Energy"],
    propertyType="StressFreeStrain",
    tip="Monoclinic stress-free strain",
    discussion=xmlmenudump.loadFile(
        'DISCUSSIONS/engine/property/anisostressfreestrain.xml'))

reg.fluxInfo(fluxes=[problem.Stress])
    
#########

reg = PropertyRegistration(
    'Mechanical:StressFreeStrain:Anisotropic:Triclinic',
    AnisotropicStressFreeStrain,
    "ooflib.SWIG.engine.property.stressfreestrain.stressfreestrain",
    26,
    [symmmatrix.TriclinicRank2TensorParameter(
            'epsilon0',
            symmmatrix.TriclinicRank2Tensor(xx=1.0, yy=1.0, zz=1.0),
            tip='Stress-free strain tensor')],
    outputs=["Strain", "Energy"],
    propertyType="StressFreeStrain",
    tip="Triclinic stress-free strain",
    discussion=xmlmenudump.loadFile(
        'DISCUSSIONS/engine/property/anisostressfreestrain.xml'))

reg.fluxInfo(fluxes=[problem.Stress])
    
